## wait4x 3.6.0

=== Makefile ===
# Copyright 2019-2025 The Wait4X Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# =============================================================================
# Configuration
# =============================================================================

# Go configuration
GO_BINARY ?= $(shell which go)
GO_ENVIRONMENTS ?=
GO_VERSION ?= $(shell $(GO_BINARY) version | cut -d' ' -f3 | sed 's/go//')

# Wait4X configuration
WAIT4X_BINARY_NAME ?= wait4x
WAIT4X_MODULE_NAME ?= wait4x.dev/v3
WAIT4X_MAIN_PATH ?= cmd/wait4x/main.go

# Test configuration
WAIT4X_COVERAGE_IGNORE_PACKAGES ?= ${WAIT4X_MODULE_NAME}/examples ${WAIT4X_MODULE_NAME}/cmd

# Build configuration
WAIT4X_BUILD_OUTPUT ?= ${CURDIR}/dist
WAIT4X_BUILD_OS ?= $(shell go env GOOS)
WAIT4X_BUILD_ARCH ?= $(shell go env GOARCH)
WAIT4X_BUILD_CGO ?= 0

# Version information
WAIT4X_COMMIT_REF_SLUG ?= $(shell [ -d ./.git ] && (git symbolic-ref -q --short HEAD || git describe --tags --always 2>/dev/null || echo "unknown"))
WAIT4X_COMMIT_HASH ?= $(shell [ -d ./.git ] && git rev-parse HEAD 2>/dev/null || echo "unknown")
WAIT4X_BUILD_TIME ?= $(shell date -u '+%FT%TZ')

# Change output to .exe for windows
ifeq (windows,$(filter windows,$(WAIT4X_BUILD_OS) $(TARGETOS)))
WAIT4X_BINARY_NAME := ${WAIT4X_BINARY_NAME}.exe
endif

# =============================================================================
# Build flags and LDFLAGS
# =============================================================================

# Base LDFLAGS for reproducible builds and metadata
WAIT4X_BUILD_LDFLAGS ?= -buildid= -w \
	-X $(WAIT4X_MODULE_NAME)/internal/cmd.BuildTime=$(WAIT4X_BUILD_TIME)

# Add version information if available
ifneq ($(WAIT4X_COMMIT_REF_SLUG),)
WAIT4X_BUILD_LDFLAGS += -X $(WAIT4X_MODULE_NAME)/internal/cmd.AppVersion=$(WAIT4X_COMMIT_REF_SLUG)
endif

ifneq ($(WAIT4X_COMMIT_HASH),)
WAIT4X_BUILD_LDFLAGS += -X $(WAIT4X_MODULE_NAME)/internal/cmd.GitCommit=$(WAIT4X_COMMIT_HASH)
endif

# Build flags for reproducible builds
WAIT4X_BUILD_FLAGS ?= -trimpath -ldflags="$(WAIT4X_BUILD_LDFLAGS)"
WAIT4X_RUN_FLAGS ?= -ldflags="$(WAIT4X_BUILD_LDFLAGS)"

# Runtime flags
WAIT4X_FLAGS ?= 

# =============================================================================
# Utility functions
# =============================================================================

# Check if a command exists
check_cmd = $(shell command -v $(1) 2> /dev/null)

# Filter coverage output to exclude ignored packages
filter_coverage = @grep $(foreach pkg,$(WAIT4X_COVERAGE_IGNORE_PACKAGES),-v -e "$(pkg)") coverage.out.tmp > coverage.out

# Common build function
define build_binary
	@mkdir -p $(WAIT4X_BUILD_OUTPUT)
	CGO_ENABLED=$(WAIT4X_BUILD_CGO) GOOS=$(WAIT4X_BUILD_OS) GOARCH=$(WAIT4X_BUILD_ARCH) \
	$(GO_ENVIRONMENTS) $(GO_BINARY) build -v $(1) \
		-o $(WAIT4X_BUILD_OUTPUT)/$(2) $(WAIT4X_MAIN_PATH)
endef

# =============================================================================
# Targets
# =============================================================================

.PHONY: help
help: ## Show this help message
	@echo " __      __        .__  __     _________  ___"
	@echo "/  \    /  \_____  |__|/  |_  /  |  \   \/  /"
	@echo "\   \/\/   /\__  \ |  \   __\/   |  |\     / "
	@echo " \        /  / __ \|  ||  | /    ^   /     \ "
	@echo "  \__/\  /  (____  /__||__| \____   /___/\  \\"
	@echo "       \/        \/              |__|     \_/"
	@echo ""
	@echo "Available targets:"
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {printf "  \033[36m%-20s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)
	@echo ""
	@echo "Environment variables:"
	@echo "  GO_BINARY                       Go binary to use (default: $(GO_BINARY))"
	@echo "  GO_ENVIRONMENTS                 Additional environment variables for Go (default: $(if $(GO_ENVIRONMENTS),$(GO_ENVIRONMENTS),none))"
	@echo "  WAIT4X_BUILD_OUTPUT             Build output directory (default: ${WAIT4X_BUILD_OUTPUT})"
	@echo "  WAIT4X_BUILD_OS                 Target OS for cross-compilation (default: $(WAIT4X_BUILD_OS))"
	@echo "  WAIT4X_BUILD_ARCH               Target architecture for cross-compilation (default: $(WAIT4X_BUILD_ARCH))"
	@echo "  WAIT4X_FLAGS                    Additional flags for wait4x binary (default: $(if $(WAIT4X_FLAGS),$(WAIT4X_FLAGS),none))"
	@echo "  WAIT4X_COVERAGE_IGNORE_PACKAGES Space-separated list of packages to exclude from coverage (default: ${WAIT4X_COVERAGE_IGNORE_PACKAGES})"

.PHONY: version
version: ## Show version information
	@echo "Go version: $(GO_VERSION)"
	@echo "Build OS: $(WAIT4X_BUILD_OS)"
	@echo "Build ARCH: $(WAIT4X_BUILD_ARCH)"
	@echo "Commit ref: $(WAIT4X_COMMIT_REF_SLUG)"
	@echo "Commit hash: $(WAIT4X_COMMIT_HASH)"
	@echo "Build time: $(WAIT4X_BUILD_TIME)"
	@echo "Coverage ignore packages: $(WAIT4X_COVERAGE_IGNORE_PACKAGES)"

.PHONY: show-coverage-config
show-coverage-config: ## Show current coverage configuration
	@echo "Coverage ignore packages: $(WAIT4X_COVERAGE_IGNORE_PACKAGES)"
	@echo "To modify, set WAIT4X_COVERAGE_IGNORE_PACKAGES environment variable"
	@echo "Example: WAIT4X_COVERAGE_IGNORE_PACKAGES='pkg1 pkg2' make test"

.PHONY: clean
clean: ## Clean build artifacts
	@echo "Cleaning build artifacts..."
	@rm -rf $(WAIT4X_BUILD_OUTPUT)
	@go clean -cache -testcache -modcache
	@echo "Clean complete!"

.PHONY: deps
deps: ## Download and tidy dependencies
	@echo "Downloading dependencies..."
	$(GO_ENVIRONMENTS) $(GO_BINARY) mod download
	$(GO_ENVIRONMENTS) $(GO_BINARY) mod tidy
	@echo "Dependencies ready!"

.PHONY: check-deps
check-deps: ## Check for outdated dependencies
	@echo "Checking for outdated dependencies..."
	@$(GO_ENVIRONMENTS) $(GO_BINARY) list -u -m all | grep -v "go:" || echo "All dependencies are up to date"

.PHONY: test
test: ## Run tests with coverage
	@echo "Running tests..."
	$(GO_ENVIRONMENTS) $(GO_BINARY) test -v -race -covermode=atomic -coverprofile=coverage.out.tmp ./...
	@$(filter_coverage) > coverage.out
	@rm coverage.out.tmp
	@echo "Test coverage report generated: coverage.out"

.PHONY: test-short
test-short: ## Run tests without race detection and integration tests
	@echo "Running tests (short mode)..."
	$(GO_ENVIRONMENTS) $(GO_BINARY) test -v -short -covermode=atomic -coverprofile=coverage.out.tmp ./...
	@$(filter_coverage) > coverage.out
	@rm coverage.out.tmp

.PHONY: test-coverage
test-coverage: ## Run tests and show coverage report
	@echo "Running tests with coverage..."
	$(GO_ENVIRONMENTS) $(GO_BINARY) test -v -race -covermode=atomic -coverprofile=coverage.out.tmp ./...
	@$(filter_coverage) > coverage.out
	@rm coverage.out.tmp
	@echo "Coverage report:"
	$(GO_ENVIRONMENTS) $(GO_BINARY) tool cover -func=coverage.out
	@echo ""
	@echo "HTML coverage report:"
	$(GO_ENVIRONMENTS) $(GO_BINARY) tool cover -html=coverage.out -o coverage.html
	@echo "Coverage report saved to coverage.html"

.PHONY: lint
lint: ## Run all linting checks
	@echo "Running linting checks..."
	@$(MAKE) check-gofmt
	@$(MAKE) check-revive
	@$(MAKE) check-govet
	@echo "All linting checks passed!"

.PHONY: check-gofmt
check-gofmt: ## Check Go code formatting
	@echo "Checking Go code formatting..."
	@if [ -n "$(shell gofmt -s -l .)" ]; then \
		echo "❌ Go code is not formatted. Run 'make fmt' to fix."; \
		exit 1; \
	fi
	@echo "✅ Go code formatting is correct"

.PHONY: fmt
fmt: ## Format Go code
	@echo "Formatting Go code..."
	$(GO_ENVIRONMENTS) $(GO_BINARY) fmt ./...
	gofmt -s -w .
	@echo "✅ Go code formatted"

.PHONY: check-revive
check-revive: ## Run revive linter
	@echo "Running revive linter..."
	@if [ -z "$(call check_cmd,revive)" ]; then \
		echo "❌ revive not found. Install with: go install github.com/mgechev/revive@latest (or run 'nix develop' to install)"; \
		exit 1; \
	fi
	revive -config .revive.toml -formatter friendly ./...

.PHONY: check-govet
check-govet: ## Run go vet
	@echo "Running go vet..."
	$(GO_ENVIRONMENTS) $(GO_BINARY) vet ./...

.PHONY: security
security: ## Run security checks
	@echo "Running security checks..."
	@if [ -n "$(call check_cmd,gosec)" ]; then \
		gosec ./...; \
	else \
		echo "⚠️  gosec not found. Install with: go install github.com/securecodewarrior/gosec/v2/cmd/gosec@latest (or run 'nix develop' to install)"; \
	fi

.PHONY: build
build: ## Build Wait4X binary
	@echo "Building Wait4X..."
	$(call build_binary,$(WAIT4X_BUILD_FLAGS),$(WAIT4X_BINARY_NAME))
	@echo "✅ Binary built: $(WAIT4X_BUILD_OUTPUT)/$(WAIT4X_BINARY_NAME)"

.PHONY: build-debug
build-debug: ## Build Wait4X binary with debug information
	@echo "Building Wait4X (debug mode)..."
	$(call build_binary,-gcflags="all=-N -l",$(WAIT4X_BINARY_NAME)-debug)
	@echo "✅ Debug binary built: $(WAIT4X_BUILD_OUTPUT)/$(WAIT4X_BINARY_NAME)-debug"

.PHONY: build-cross
build-cross: ## Build Wait4X for multiple platforms
	@echo "Building Wait4X for multiple platforms..."
	@mkdir -p $(WAIT4X_BUILD_OUTPUT)
	@for os in linux darwin windows; do \
		for arch in amd64 arm64; do \
			if [ "$$os" = "windows" ]; then \
				binary_name="$(WAIT4X_BINARY_NAME).exe"; \
			else \
				binary_name="$(WAIT4X_BINARY_NAME)"; \
			fi; \
			echo "Building for $$os/$$arch..."; \
			CGO_ENABLED=0 GOOS=$$os GOARCH=$$arch \
			$(GO_ENVIRONMENTS) $(GO_BINARY) build -v $(WAIT4X_BUILD_FLAGS) \
				-o $(WAIT4X_BUILD_OUTPUT)/$(WAIT4X_BINARY_NAME)-$$os-$$arch/$$binary_name $(WAIT4X_MAIN_PATH); \
		done; \
	done
	@echo "✅ Cross-platform builds complete!"

.PHONY: install
install: build ## Install Wait4X to system
	@echo "Installing Wait4X..."
	$(GO_ENVIRONMENTS) $(GO_BINARY) install $(WAIT4X_BUILD_FLAGS) $(WAIT4X_MAIN_PATH)
	@echo "✅ Wait4X installed to $(shell go env GOPATH)/bin/"

.PHONY: run
run: ## Run Wait4X
	@echo "Running Wait4X..."
	$(GO_ENVIRONMENTS) $(GO_BINARY) run $(WAIT4X_RUN_FLAGS) $(WAIT4X_MAIN_PATH) $(WAIT4X_FLAGS)

.PHONY: run-examples
run-examples: ## Run example configurations
	@echo "Running examples..."
	@if [ -d "examples" ]; then \
		for example in examples/*/; do \
			if [ -f "$$example/main.go" ]; then \
				echo "Running example: $$(basename $$example)"; \
				cd $$example && go run main.go; \
				cd - > /dev/null; \
			fi; \
		done; \
	else \
		echo "No examples directory found"; \
	fi

.PHONY: docker-build
docker-build: ## Build Docker image
	@echo "Building Docker image..."
	docker build -t wait4x:latest .
	@echo "✅ Docker image built: wait4x:latest"

.PHONY: docker-run
docker-run: ## Run Wait4X in Docker
	@echo "Running Wait4X in Docker..."
	docker run --rm wait4x:latest $(WAIT4X_FLAGS)

.PHONY: release
release: clean deps lint test build-cross ## Prepare release (clean, lint, test, build)
	@echo "✅ Release preparation complete!"

.PHONY: ci
ci: deps lint test ## Run CI pipeline
	@echo "✅ CI pipeline completed successfully!"

# =============================================================================
# Development helpers
# =============================================================================

.PHONY: dev-setup
dev-setup: ## Setup development environment
	@echo "Setting up development environment..."
	@echo "Using Nix for development environment setup..."
	@echo "Run 'nix develop' to enter the development shell with all tools pre-installed"
	@echo "Or run 'nix build' to build the project"
	@echo "✅ Development environment ready! (Managed by Nix)"

# =============================================================================
# Documentation
# =============================================================================

.PHONY: docs
docs: ## Generate documentation
	@echo "Generating documentation..."

## wait4x 3.5.1

=== debian/changelog ===
wait4x (3.5.1-1) unstable; urgency=medium

  * Initial release (Closes: #1101564)

 -- Lena Voytek <lena@voytek.dev>  Fri, 29 Aug 2025 13:49:23 -0400

=== debian/control ===
Source: wait4x
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Lena Voytek <lena@voytek.dev>,
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-sequence-golang,
               golang-any,
               golang-github-antchfx-htmlquery-dev,
               golang-github-fatih-color-dev,
               golang-github-go-logr-logr-dev,
               golang-github-go-logr-stdr-dev,
               golang-github-go-logr-zerologr-dev,
               golang-github-go-redis-redis-dev,
               golang-github-go-sql-driver-mysql-dev,
               golang-github-lib-pq-dev,
               golang-github-miekg-dns-dev,
               golang-github-rabbitmq-amqp091-go-dev,
               golang-github-rs-zerolog-dev,
               golang-github-spf13-cobra-dev,
               golang-github-stretchr-testify-dev,
               golang-github-tidwall-gjson-dev,
               golang-google-grpc-dev,
               golang-mongodb-mongo-driver-dev,
               golang-mvdan-sh-dev,
               help2man
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/wait4x
Vcs-Git: https://salsa.debian.org/go-team/packages/wait4x.git
Homepage: https://github.com/wait4x/wait4x
XS-Go-Import-Path: wait4x.dev/v3

Package: wait4x
Section: net
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Wait for a port or a service to enter the requested state. (program)
 This package provides a command-line tool to wait for a port or a service
 to enter the requested state, such as being available or returning a specific
 HTTP status code. It can be used in scripts or as part of deployment processes
 to ensure that services are ready before proceeding with further actions.

Package: golang-wait4x-wait4x-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Wait for a port or a service to enter the requested state. (library)
 This package provides a Go library to wait for a port or a service to enter
 the requested state, such as being available or returning a specific HTTP
 status code. It can be used in Go applications to ensure that services are
 ready before proceeding with further actions.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM

export DH_GOLANG_BUILDPKG := wait4x.dev/v3/cmd/wait4x
export GOFLAGS := -tags=disable_influxdb,disable_kafka,disable_redis,disable_temporal

MAN_NAME_SECTION="Wait for a port or a service to enter the requested state"

%:
	dh $@ --builddirectory=_build --buildsystem=golang

execute_after_dh_auto_install:
	# Generate man page
	help2man $(CURDIR)/debian/tmp/usr/bin/wait4x --name=$(MAN_NAME_SECTION) --version-string=$(DEB_VERSION_UPSTREAM) > debian/wait4x.1

override_dh_auto_test:
	# Most tests require either test container libraries or an internet
	# connection, skip for now

=== debian/tests/control ===
Tests: wait4-shell-commands
Restrictions: allow-stderr

Tests: wait4-apache2
Restrictions: needs-root allow-stderr breaks-testbed
Depends: @, apache2

Tests: check-go-library
Restrictions: allow-stderr
Depends: @,
         golang-any,
         golang-github-go-logr-logr-dev,
         golang-github-stretchr-testify-dev,
         golang-github-stretchr-objx-dev,
         golang-github-davecgh-go-spew-dev,
         golang-github-pmezard-go-difflib-dev,
         golang-gopkg-yaml.v3-dev

=== debian/watch ===
version=4
opts=\
  filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
  downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
  searchmode=plain \
  https://api.github.com/repos/wait4x/wait4x/git/matching-refs/tags/ \
  https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@

## wait4x 3.6.0

=== debian/changelog ===
wait4x (3.6.0-1) unstable; urgency=medium

  * New upstream release 3.6.0
  * Enable kafka support
    - d/rules: Remove disable_kafka
    - d/control: Add golang-github-segmentio-kafka-go-dev dependency
  * Update standards version and remove Priority: optional
  * Remove golang-github-go-redis-redis-dev dependency for now

 -- Lena Voytek <lena@voytek.dev>  Fri, 06 Feb 2026 14:41:03 -0500

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: wait4x
 Section: golang
-Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Lena Voytek <lena@voytek.dev>,
 Rules-Requires-Root: no
@@ -12,12 +11,12 @@
                golang-github-go-logr-logr-dev,
                golang-github-go-logr-stdr-dev,
                golang-github-go-logr-zerologr-dev,
-               golang-github-go-redis-redis-dev,
                golang-github-go-sql-driver-mysql-dev,
                golang-github-lib-pq-dev,
                golang-github-miekg-dns-dev,
                golang-github-rabbitmq-amqp091-go-dev,
                golang-github-rs-zerolog-dev,
+               golang-github-segmentio-kafka-go-dev,
                golang-github-spf13-cobra-dev,
                golang-github-stretchr-testify-dev,
                golang-github-tidwall-gjson-dev,
@@ -26,7 +25,7 @@
                golang-mvdan-sh-dev,
                help2man
 Testsuite: autopkgtest-pkg-go
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/go-team/packages/wait4x
 Vcs-Git: https://salsa.debian.org/go-team/packages/wait4x.git
 Homepage: https://github.com/wait4x/wait4x

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 export DEB_VERSION_UPSTREAM
 
 export DH_GOLANG_BUILDPKG := wait4x.dev/v3/cmd/wait4x
-export GOFLAGS := -tags=disable_influxdb,disable_kafka,disable_redis,disable_temporal
+export GOFLAGS := -tags=disable_influxdb,disable_redis,disable_temporal
 
 MAN_NAME_SECTION="Wait for a port or a service to enter the requested state"
